import GLProvider from './GLProvider';
import Color from 'parsegraph-color';
import Rect from 'parsegraph-rect';
export default class BasicGLProvider implements GLProvider {
    _shaders: {
        [shaderName: string]: WebGLProgram;
    };
    _id: string;
    _gl: WebGLRenderingContext;
    _container: HTMLDivElement;
    _canvas: HTMLCanvasElement;
    _backgroundColor: Color;
    _explicitWidth: number;
    _explicitHeight: number;
    constructor(id: string, background: Color);
    onContextChanged(isLost: boolean): void;
    shaders(): {
        [shaderName: string]: WebGLProgram;
    };
    id(): string;
    gl(): WebGLRenderingContext;
    canvas(): HTMLCanvasElement;
    getSize(sizeOut?: Rect): void;
    resize(w: number, h: number): void;
    setExplicitSize(w: number, h: number): void;
    getWidth(): number;
    width(): number;
    getHeight(): number;
    height(): number;
    /**
     * @return {HTMLElement} Returns the container that holds the canvas for this graph.
     */
    container(): HTMLElement;
    setBackground(color: Color | number, ...args: Array<number>): void;
    /**
     * @return {Color} Retrieves the current background color.
     */
    backgroundColor(): Color;
    /**
     * @return {boolean} Returns whether the window has a nonzero client width and height.
     */
    canProject(): boolean;
    /**
     * Renders this provider's content, resizing the canvas to its container.
     *
     * The default implementation only sets the WebGL's clear color to the
     * background but does not clear the canvas.
     *
     * @return {boolean} true if this provider needs an additional call to complete rendering its content.
     * @throws if the scene cannot be projected to, as determined by canProject
     */
    render(): boolean;
}
//# sourceMappingURL=BasicGLProvider.d.ts.map